Attribute VB_Name = "modProdSort"
Option Explicit
'sendmessage variants
Public Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageAny Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, wParam As Any, lParam As Any) As Long
Public Declare Function SendMessageByNum Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Declare Function EnumChildWindows Lib "user32" (ByVal hwndParent As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'button
Public Const BM_CLICK = &HF5&

'list box
Public Const LB_GETCOUNT = &H18B
Public Const LB_GETTEXT = &H189
Public Const LB_GETTEXTLEN = &H18A
Public Const LB_ADDSTRING = &H180
Public Const LB_RESETCONTENT = &H184
Public Const LB_GETTOPINDEX = &H18E
Public Const LB_SETTOPINDEX = &H197
Public Const LB_GETCURSEL = &H188

Public Const LB_FINDSTRING = &H18F
Public Const LB_SELECTSTRING = &H18C
Public Const LB_SETCURSEL = &H186
Public Const LB_SETSEL = &H185
Public Const LB_FINDSTRINGEXACT = &H1A2
Public Const LB_GETITEMRECT = &H198
Public Const LB_GETITEMDATA = &H199
Public Const LB_ERR = -1

Public Const LBS_EXTENDEDSEL = &H800&
Public Const LBS_MULTIPLESEL = &H8&

'window
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202

Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)

Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, _
   ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
'setwindowpos
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_SHOWWINDOW = &H40

Public Const HWND_NOTOPMOST = -2
Public Const HWND_TOPMOST = -1
'
Public arrProds() As String            'array for product names
Public lDelay As Long
Public hWndLBFreeMove As Long
Public hWndListBox As Long
Public hWndLBUpArrow As Long
Public hWndLBDownArrow As Long
Public hWndDlg As Long
Public CATIA As Application '  Object
'---------------------------------------------------------------------------------------
' Procedure : GetProductsListFromList
' Author    : jherzog
' Date      : 13.02.2015
' Time      : 15:03
' Languages : VB6 Pro SP6
' V5-Release: V5R19/21
' Purpose   : Read entries in 'Graph tree reordering' list box
'           : adds the entries to an array and a list box
' Parms     : strDlgWnd: string 'Graph tree reordering' (as of now)
' Ret. Value: (arrProds: Array of list box entries
'
' Syntax    : GetProductsListFromList "Graph tree reordering", arrProds
'
' Prereqs   : opened catia dialog 'Graph tree reordering'
' Remarks   : Since the VB-List box is not sorted, the array is used as buffer and sorted
'           : May crash, if another programme titled 'Graph tree reordering' exists
'---------------------------------------------------------------------------------------
' Changes   : 28.03.2015: Removed 2nd argument in call(is now global)
'
'
'---------------------------------------------------------------------------------------
Public Sub GetProductsListFromList(strDlgWnd As String)
   Dim strBuff As String
   Dim iNum As Integer
   Dim n As Integer
   Dim iTextLen As Integer

   frmProdSort.lb_Prods.Clear                                        'clear list
   
   hWndDlg = FindWindow(vbNullString, strDlgWnd)                     'get parent handle
   If hWndDlg = 0 Then                                               'no such window
      MsgBox "Dialog not found!", vbOKOnly Or vbCritical, "GetProductsList"
      Exit Sub
   End If
   EnumChildWindows hWndDlg, AddressOf EnumChildProc, ByVal 0&       'get children handles

   iNum = SendMessageByNum(hWndListBox, LB_GETCOUNT, 0&, 0&)         'get number of entries
   ReDim arrProds(iNum - 1)
   
   For n = 0 To iNum - 1
      iTextLen = SendMessageByNum(hWndListBox, LB_GETTEXTLEN, n, 0&)
      strBuff = Space$(iTextLen)
      SendMessageString hWndListBox, LB_GETTEXT, n, strBuff          'read lb entry text
      frmProdSort.lb_Prods.AddItem strBuff                           'add to list
      arrProds(n) = strBuff                                          'add to array
   Next
End Sub

'---------------------------------------------------------------------------------------
' Procedure : EnumChildProc
' Author    : jherzog
' Date      : 13.02.2015
' Time      : 15:14
' Languages : VB6 Pro SP6
' V5-Release: V5R19/21
' Purpose   : Find and identify child windows
' Parms     : hwndChild: handle to a child window
'           : lParam: not used
' Ret. Value: Handles to three buttons and the list box holding the product entries
'           ' The handles are declared 'Public'
' Syntax    : - (callback function)
'
' Prereqs   : Call to EnumChildWindows
' Remarks   : Button and list box identifiers supplied by Spy++
'---------------------------------------------------------------------------------------
'
Public Function EnumChildProc(ByVal hwndChild As Long, ByVal lParam As Long) As Long
   Dim strBuff As String                                    'string buffer
   
   strBuff = Space$(GetWindowTextLength(hwndChild) + 1)     'Get the windowtext length
   GetWindowText hwndChild, strBuff, Len(strBuff)           'get the window text
   strBuff = Left$(strBuff, Len(strBuff) - 1)               'remove the last Chr$(0)
   
   Select Case strBuff
      Case "ListProd"                                       'look for 'ListProd'
         hWndListBox = hwndChild                            'assign to public handle
      Case "Move Up"                                        'look for 'MoveUp'
         hWndLBUpArrow = hwndChild
      Case "Move Down"                                      'look for 'MoveDown'
         hWndLBDownArrow = hwndChild
      Case "Free Move"                                      'look for 'MoveDown'
         hWndLBFreeMove = hwndChild
      Case Else
   End Select
   EnumChildProc = 1                                        'continue enumeration
End Function

' QuickSort-Algorithmus
' Autor:   Dieter Otter
' www.tools4vb.de
'
' vSort() : zu sortierendes Array
' lngStart, lngEnd: zu sortierender Bereich
' ==========================================
Public Sub QuickSort(vSort As Variant, _
  Optional ByVal lngStart As Variant, _
  Optional ByVal lngEnd As Variant)
 
   ' Wird die Bereichsgrenze nicht angegeben,
   ' so wird das gesamte Array sortiert
   
   If IsMissing(lngStart) Then lngStart = LBound(vSort)
   If IsMissing(lngEnd) Then lngEnd = UBound(vSort)
   
   Dim i As Long
   Dim j As Long
   Dim H As Variant
   Dim X As Variant
   
   i = lngStart
   j = lngEnd
   X = vSort((lngStart + lngEnd) / 2)
   
   ' Array aufteilen
   Do
   
      While (vSort(i) < X)
         i = i + 1
      Wend
      While (vSort(j) > X)
         j = j - 1
      Wend
      
      If (i <= j) Then
         ' Wertepaare miteinander tauschen
         H = vSort(i)
         vSort(i) = vSort(j)
         vSort(j) = H
         i = i + 1
         j = j - 1
      End If
   Loop Until (i > j)
   
   ' Rekursion (Funktion ruft sich selbst auf)
   If (lngStart < j) Then QuickSort vSort, lngStart, j
   If (i < lngEnd) Then QuickSort vSort, i, lngEnd
End Sub


'---------------------------------------------------------------------------------------------
' Procedure : SetTopMost
' Author    : jherzog
' Date      : 11.07.2014
' Time      : 19:50
' Languages : VB6 Pro
' V5-Release: V5R19/21
' Purpose   : Set/Unset window topmost attribute
' Parms     : hWndCaller: Handle of calling window
' Ret. Value: -
'
' Syntax    : SetTopMost hWnd, True
'---------------------------------------------------------------------------------------
'
Public Sub SetTopMost(hWndCaller As Long, bOnOff As Boolean)
   Dim ret As Long
   
   If bOnOff Then          ' Turn on the TopMost attribute.
       ret = SetWindowPos(hWndCaller, HWND_TOPMOST, 0, 0, 0, 0, _
         SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_NOMOVE)
   Else                    ' Turn off the TopMost attribute.
       ret = SetWindowPos(hWndCaller, HWND_NOTOPMOST, 0, 0, 0, 0, _
         SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_NOMOVE)
   End If
End Sub

Sub GetCatiaObjectProdSort()
    
   On Error Resume Next                                     'Disable automatic error handling
   Set CATIA = GetObject(, "CATIA.Application")

   If (Err.Number <> 0) Then                                'Manually handle all errors
       MsgBox Err.Description & vbCrLf & "Is Catia running?" _
         & vbCrLf & "Trying to start Catia!" _
         , vbOKOnly Or vbInformation, "GetCatiaObject"
       
       On Error GoTo 0                                      'Invalidates the Resume Next and clears the error
       
       DoEvents
       Set CATIA = CreateObject("CATIA.Application")        'try to start catia
       
       Do                                                   'wait for it
          If Not CATIA Is Nothing Then                      'then it's something
             Exit Do
          End If
          DoEvents
       Loop
       CATIA.Visible = True                                 'show the main window
   End If
   On Error GoTo 0                                          'Invalidates the Resume Next and clears the error
End Sub

'---------------------------------------------------------------------------------------
' Procedure : HiWord/LoWord
' Author    : jherzog
' Date      : 20.07.2014
' Time      : 17:58
' Languages : VB6 Pro
' V5-Release: V5R19/21
' Purpose   : retrieve the value of the hi/lo byte
' Parms     : a long integer
' Ret. Value: the hi/lo byte
'
' Syntax    : HiWord(lBignumber)
'---------------------------------------------------------------------------------------
'
Public Function HIWORD(dwValue As Long) As Integer
  MoveMemory HIWORD, ByVal VarPtr(dwValue) + 2, 2
End Function

Public Function LOWORD(dwValue As Long) As Integer
  MoveMemory LOWORD, dwValue, 2
End Function

' Combines two integers into a long integer
Public Function MAKELONG(wLow As Long, wHigh As Long) As Long
  MAKELONG = LOWORD(wLow) Or (&H10000 * LOWORD(wHigh))
End Function

' Combines two integers into a long integer
Public Function MAKELPARAM(wLow As Long, wHigh As Long) As Long
  MAKELPARAM = MAKELONG(wLow, wHigh)
End Function

